import bpy

def create_group(group_name):
    if group_name in bpy.data.groups:
        group = bpy.data.groups[group_name]
    else:
        group = bpy.data.groups.new(group_name)
    return group

def create_and_link_cube(group):
    bpy.ops.mesh.primitive_cube_add()
    group.objects.link(bpy.context.object)

def duplicate_cube():
    for z in range(0, 3):
        for y in range(0, 3):
            for x in range(0, 3):
                bpy.ops.object.select_all(action='TOGGLE')
                first_cube.select = True
                bpy.ops.object.duplicate()
                bpy.ops.transform.translate(value=(first_cube.dimensions[0]*x, first_cube.dimensions[1]*y, first_cube.dimensions[2]*z))

def delete_cubes():
    bpy.ops.object.select_all(action='TOGGLE')
    indices = [4, 10, 12, 13, 14, 16, 22]
    for index in indices:
        group.objects[index].select = True
    bpy.ops.object.delete()
    
def geometry_cleanup(group_name):
    bpy.ops.object.select_same_group(group=group_name)
    bpy.ops.object.join()
    bpy.ops.object.editmode_toggle()
    bpy.ops.mesh.remove_doubles()
    bpy.ops.object.editmode_toggle()

# fractal method starts here
group_name = "fractal"
group = create_group(group_name)
create_and_link_cube(group)
first_cube = bpy.context.active_object

for i in range(0,4):
    duplicate_cube()
    delete_cubes()
    geometry_cleanup(group_name)
    first_cube = group.objects[0]
    
#bpy.ops.group.objects_remove(group=group_name)